<template>
  <q-page class="q-px-md q-mt-md">
    <q-table
      :rows-per-page-options="[15, 25, 50]"
      :pagination.sync="pagination"
      :columns="columns"
      :loading="loading"
      :filter="filter"
      :data="data"
      separator="cell"
      row-key="id"
      @request="onRequest"
    >
      <template slot="top" slot-scope="props">
        <q-btn
          push
          rounded
          color="primary"
          icon="add"
          to="/v2/group/add"
          v-show="permissions('add')"
          >Add Group
        </q-btn>
      </template>
      <q-tr slot="top-row">
        <q-td colspan="3">
          <q-select
            filled
            label="Owner"
            error-message="กรุณาเลือก Owner"
            v-model="filter.member_created_id"
            :options="memberListOptions"
            use-input
            hide-selected
            fill-input
            @filter="memberListFilter"
            input-debounce="0"
            emit-value
            map-options
            :option-value="'id'"
            :option-label="opt => `${opt.name} - ${opt.user}`"
          >
            <template v-slot:append>
              <q-icon
                name="close"
                @click.stop="filter.member_created_id = undefined"
                class="cursor-pointer"
              />
            </template>
            <template v-slot:hint>
              Field hint
            </template>
          </q-select>
        </q-td>
        <q-td colspan="2"></q-td>
        <q-td>
          <q-toggle
            key="is_display"
            v-model="filter.is_display"
            toggle-indeterminate
            :false-value="0"
            :true-value="1"
          />
        </q-td>
        <q-td>
          <q-toggle
            key="status"
            v-model="filter.status"
            :false-value="0"
            :true-value="1"
            toggle-indeterminate
          />
        </q-td>
        <q-td colspan="3"></q-td>
      </q-tr>
      <q-tr slot="body" slot-scope="props" :props="props">
        <q-td
          key="No"
          :props="props"
          :style="{ width: '20px', whiteSpace: 'normal' }"
          >{{ props.rowIndex + 1 }}
        </q-td>
        <q-td key="member_created_name" :props="props">
          {{ props.row.member_created_name }}
        </q-td>
        <q-td
          key="name"
          :props="props"
          :style="{ width: '500px', whiteSpace: 'normal' }"
        >
          <router-link :to="{ path: `/v2/group/${props.row.id}` }">
            {{ props.row.name }}
          </router-link>
        </q-td>
        <q-td
          key="code"
          :props="props"
          :style="{ width: '100px', whiteSpace: 'normal' }"
          >{{ props.row.code }}
        </q-td>
        <q-td
          key="image"
          :props="props"
          :style="{ width: '200px', whiteSpace: 'normal' }"
        >
          <template>
            <img :src="props.row.image" class="image" />
          </template>
        </q-td>
        <q-td
          key="is_display"
          :props="props"
          :style="{ width: '20px', whiteSpace: 'normal' }"
        >
          <q-toggle
            key="is_display"
            v-model="props.row.is_display"
            :false-value="0"
            :true-value="1"
            @input="ChangeDisplay(props.row)"
            :disable="!permissions('change')"
          />
        </q-td>
        <q-td
          key="status"
          :props="props"
          :style="{ width: '20px', whiteSpace: 'normal' }"
        >
          <q-toggle
            v-model="props.row.status"
            :false-value="0"
            :true-value="1"
            @input="ChangeStatus(props.row)"
            :disable="!permissions('change')"
          />
        </q-td>
        <q-td style="width: 5%;">
          <q-btn
            :to="{ path: `/v2/group/${props.row.id}/provider` }"
            color="blue"
            label="provider"
          />
        </q-td>
        <q-td style="width: 5%;">
          <q-btn
            :to="{ path: `/v2/group/${props.row.id}/type` }"
            color="blue"
            label="type"
          />
        </q-td>
        <q-td
          key="action"
          :props="props"
          :style="{ width: '5%', whiteSpace: 'normal' }"
        >
          <div class="row items-center justify-left no-wrap">
            <q-btn
              size="sm"
              round
              rounded
              color="secondary"
              icon="edit"
              class="q-ml-xs"
              :to="{ path: `/v2/group/${props.row.id}` }"
              v-show="permissions('change')"
            />
            <q-btn
              size="sm"
              round
              rounded
              color="negative"
              icon="delete"
              @click="DeleteRow(props.row)"
              class="q-ml-xs"
              v-show="permissions('delete')"
            />
          </div>
        </q-td>
      </q-tr>
    </q-table>
  </q-page>
</template>

<script>
import { mapState, mapGetters, mapActions } from "vuex";

export default {
  name: "Group",
  data() {
    return {
      data: [],
      search: "",
      columns: [
        {
          name: "No",
          label: "No",
          field: "No",
          require: true,
          align: "left",
          stortable: true
        },
        {
          label: "owner",
          name: "member_created_name",
          field: "member_created_name",
          align: "left"
        },
        {
          name: "name",
          label: "Name",
          field: "name",
          require: true,
          align: "left",
          stortable: true
        },
        {
          name: "code",
          label: "Code",
          field: "code",
          require: true,
          align: "left",
          stortable: true
        },
        {
          name: "image",
          label: "Image",
          field: "image",
          require: true,
          align: "left",
          stortable: true
        },
        {
          name: "is_display",
          label: "Display",
          field: "is_display",
          require: true,
          align: "left",
          stortable: true
        },
        {
          name: "status",
          label: "Status",
          field: "status",
          require: true,
          align: "left",
          stortable: true
        },
        {
          label: "Provider",
          align: "center"
        },
        {
          label: "type",
          align: "center"
        },
        {
          name: "action",
          label: "Action",
          field: "id",
          require: true,
          align: "left",
          stortable: true
        }
      ],
      filter: {
        member_created_id: undefined
      },
      separator: "horizontal",
      pagination: {
        sortBy: "desc",
        descending: false,
        page: 1,
        rowsPerPage: 15,
        rowsNumber: 0
      },
      loading: false,
      permissionsFunction: undefined,
      memberListOptions: []
    };
  },
  async created() {
    this.permissionsFunction = await this.initPermission("group");
    if (!this.listGetter) {
      this.loading = true;
      await this.memberLoad();
    }
    await this.onRequest({
      pagination: this.pagination,
      filter: undefined
    });
  },
  computed: {
    ...mapGetters("member", {
      memberList: "listGetter"
    }),
    permissions() {
      if (this.permissionsFunction) {
        return this.permissionsFunction;
      }
      return () => false;
    }
  },
  methods: {
    ...mapActions("permission", {
      initPermission: "permission"
    }),
    ...mapActions("member", {
      memberLoad: "load"
    }),
    ...mapActions("group/v2", [
      "load_list",
      "load_provider",
      "update",
      "remove"
    ]),
    async onRequest(props) {
      const { page, rowsPerPage, sortBy, descending } = props.pagination;
      const filter = props.filter;
      this.loading = true;
      const {
        data: { results, page: resultPage, per_page, total }
      } = await this.load_list({
        page: page,
        page_limit: rowsPerPage,
        ...filter
      });
      // clear out existing data and add new
      this.data.splice(0, this.data.length, ...results);

      // don't forget to update local pagination object
      this.pagination.page = resultPage;
      this.pagination.rowsPerPage = per_page;
      this.pagination.rowsNumber = total;
      this.pagination.sortBy = sortBy;
      this.pagination.descending = descending;
      this.loading = false;
    },
    ChangeStatus(row) {
      const prev = row.status == 0 ? 1 : 0;
      this.$q
        .dialog({
          title: "Confirm",
          message: `Do you really want Change Status to Group ${row.name} later, ok?`,
          ok: {
            push: true
          },
          cancel: {
            push: true,
            color: "negative"
          },
          persistent: true
        })
        .onOk(() => {
          this.update({
            id: row.id,
            data: {
              ...row
            }
          })
            .then(async data => {
              await this.onRequest({
                pagination: this.pagination,
                filter: this.filter
              });
              this.$dialog.alert("", "Update Group Success");
            })
            .catch(ex => {
              row.status = prev;
              this.$dialog.errorException(ex);
            });
        })
        .onCancel(() => {
          row.status = prev;
        });
    },
    ChangeDisplay(row) {
      const prev = row.is_display == 0 ? 1 : 0;
      this.$q
        .dialog({
          title: "Confirm",
          message: `Do you really want Change Display to Group ${row.name} later, ok?`,
          ok: {
            push: true
          },
          cancel: {
            push: true,
            color: "negative"
          },
          persistent: true
        })
        .onOk(() => {
          this.update({
            id: row.id,
            data: {
              ...row
            }
          })
            .then(async data => {
              await this.onRequest({
                pagination: this.pagination,
                filter: this.filter
              });
              this.$dialog.alert("", "Update Group Success");
            })
            .catch(ex => {
              row.status = prev;
              this.$dialog.errorException(ex);
            });
        })
        .onCancel(() => {
          row.is_display = prev;
          // console.log('>>>> Cancel')
        });
    },
    DeleteRow(row) {
      this.$q
        .dialog({
          title: "Confirm",
          message: `Do you really want Delete Group ${row.name}, ok?`,
          ok: {
            push: true,
            color: "negative"
          },
          cancel: {
            push: true
          },
          persistent: true
        })
        .onOk(() => {
          this.remove(row.id)
            .then(async data => {
              await this.onRequest({
                pagination: this.pagination,
                filter: this.filter
              });
              this.$dialog.alert("", `Delete ${row.name} Group Success`);
            })
            .catch(ex => {
              this.$dialog.errorException(ex);
            });
        });
    },
    memberListFilter(val, update, abort) {
      update(() => {
        const needle = val.toLowerCase();
        if (needle) {
          this.memberListOptions = this.memberList.filter(
            v => `${v.name} - ${v.user}`.toLowerCase().indexOf(needle) > -1
          );
        } else {
          this.memberListOptions = this.memberList;
        }
      });
    }
  }
};
</script>
<style lang="scss" scoped>
img {
  border: 0.5px solid #ddd;
  border-radius: 8px;
  padding: 5px;
  width: 100%;
}

.image {
  border: 0.5px solid #ddd;
  border-radius: 8px;
  padding: 5px;
  width: 50%;
}
</style>
